# $Id: trackback_controller.rb 2 2005-06-20 01:15:47Z nohmad $

require 'iconv'

class TrackbackController < ApplicationController

  def index
    if @request.post? then
      listen
      render_action 'listen'
    else
      list
      render_action 'list'
    end
  end

  def list
    @pager, @trackbacks = paginate :trackbacks, :per_page => 20,
				   :order_by => 'created_at DESC'
  end

  def listen
    tb = Trackback.new(:url => @params['url'])
    txtmsg = [:title, :excerpt, :blog_name]

    # detect encoding heuristic way
    begin
      iconv = Iconv.new('utf8', 'euc-kr')
      txtmsg.each { |e| tb[e] = iconv.iconv(@params[e]) }
    rescue Iconv::IllegalSequence => is
      txtmsg.each { |e| tb[e] = @params[e] }
    end

    @result = true
    tb.save rescue @result = false
  end
end
